/// -*- c++ -*-
/// Wrappers for the PnMPI callpath module.  These take a stacktrace 
/// at each PnMPI call so that it can be exposed for other modules.
#include <mpi.h>
#include "Callpath.h"
#include "CallpathRuntime.h"
#include "callpath_internal.h"
using namespace std;


/// Runtime used to take stack traces.
static CallpathRuntime *runtime = NULL;

{{fn fn_name MPI_Init}} {
  runtime = new CallpathRuntime();
  runtime->set_chop_libc(true);
  PNMPIMOD_Callpath_callpath = runtime->doStackwalk();
  {{callfn}}
} {{endfn}}


{{fnall fn_name MPI_Init MPI_Finalize MPI_Pcontrol MPI_Comm_Rank MPI_Comm_size MPI_Initialized}} {
  PNMPIMOD_Callpath_callpath = runtime->doStackwalk();
  {{callfn}}
} {{endfnall}}


{{fn fn_name MPI_Finalize}} {
  PNMPIMOD_Callpath_callpath = runtime->doStackwalk();
  {{callfn}}
  delete runtime;
} {{endfn}}
